// Credits
// Flynn99 - Original creator
// Head to line 221 for balance tweaks!

ClearGameEventCallbacks();

Convars.SetValue("sv_alltalk", 1);
Convars.SetValue("tf_weapon_criticals", 1);
Convars.SetValue("tf_bot_reevaluate_class_in_spawnroom", 0);
Convars.SetValue("tf_bot_keep_class_after_death", 1);

::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager");
::redClassSelect <- RandomInt(1, 9)
//::redAltClassSelect <- RandomInt(1, 9)
::bluClassSelect <- RandomInt(1, 9)
//::bluAltClassSelect <- RandomInt(1, 9)
::hasVoted <- {}

::voteThreshold <- 0;
::voteText <- null;
::currentVoteCount <- 0;
::MaxPlayers <- MaxClients().tointeger();


IncludeScript("classwars/game/netpropperf.nut");

::GetPlayerUserID <- function(player)
{
    if (player != null)
    {
        return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex());
    }
    return null
}

function voteInput(player)
{
		
		local id = GetPlayerUserID(player)
		local button = NetProps.GetPropInt(player, "m_nButtons")
		local usingActionItem = NetProps.GetPropInt(player, "m_bUsingActionSlot")
		

		if(usingActionItem || (button & 33554432))
		{
		if(id in hasVoted){
		
		if(hasVoted[id] > 0) return;
	

		hasVoted[id] += 1
		currentVoteCount++
		updateVoteText()
		
		return;
		
		}
}
}

function Tick()
{
//	getThreshold();

	for (local i = 1; i <= MaxPlayers; i++)
    {
        local player = PlayerInstanceFromIndex(i);
		if(player == null) continue;
		voteInput(player);
		
	}
		
		
    
	
if(currentVoteCount != 0 && currentVoteCount >= voteThreshold) voteWin();
return 0.2;

}

function SpawnText(void)
{
	   voteText = SpawnEntityFromTable("game_text",
        {
            color = "255 255 255",
            color2 = "0 0 0",
            channel = 1,
            effect = 0,
            fadein = 0,
            fadeout = 0,
            fxtime = 0,
            holdtime = 15,
            message = "0",
            spawnflags = 1,
            x = -1,
            y = 0.125
        });


}
SpawnText(null);


function announceClass(params)
{



local classArray = [
"ERRORCLASS",
"SCOUT",
"SNIPER",
"SOLDIER",
"DEMOMAN",
"MEDIC",
"HEAVY",
"PYRO",
"SPY",
"ENGINEER"

]

local announceText = [
"The current matchup is: "
" vs "
"! FIGHT!",
"The new matchup is: "
]

   local classText = SpawnEntityFromTable("game_text",
        {
            color = "255 255 255",
            color2 = "0 0 0",
            channel = 0,
            effect = 0,
            fadein = 0,
            fadeout = 0,
            fxtime = 0,
            holdtime = 10,
            message = classArray[bluClassSelect] + announceText[1] + classArray[redClassSelect] + "\nFIGHT!\nBad matchup? Press the 'Action' button (H by default) to surrender!",
            spawnflags = 1,
            x = -1,
            y = 0.67
        });

EntFireByHandle( classText, "Display", "", 0.2, null, null );




}



function OnGameEvent_teamplay_round_win(params)
{


redClassSelect = RandomInt(1, 9);
//redAltClassSelect = RandomInt(1, 9);
bluClassSelect = RandomInt(1, 9);
//bluAltClassSelect = RandomInt(1, 9);

}

function setClass(params)
{

	local team = params.GetTeam()
	local classSelect = 0
	
	switch ( team ) 
	{
	case 2 : 
		classSelect = redClassSelect
	break;
	case 3 : 
		classSelect = bluClassSelect
	break; 
	}
	
    if(params.GetPlayerClass() != classSelect) 
	{	
	params.SetPlayerClass(classSelect);
	SetPropInt(params, "m_Shared.m_iDesiredPlayerClass", classSelect);
    params.ForceRegenerateAndRespawn();
	return;
	}

}	


// Sets up custom class specific attributes, place your nerfs / buffs here
// use  { self.AddCustomAttribute("your attribute here", x, -1); } to add attributes, for weapon specific attributes use { wep(x).AddAttribute("your attribute here", y, -1); }
// List of custom attributes: https://wiki.teamfortress.com/wiki/List_of_item_attributes
// List of custom conditions: https://developer.valvesoftware.com/wiki/Trigger_add_tf_player_condition
::setup_player <- function()
{

// We get the team id just in case you want to add exceptions for specific balance changes based on the team (in the case of the gamemode is being played on an assym map like payload / attack/defend)
local team = self.GetTeam()
local classSelect = 0

	switch ( team ) 
	{
	case 2 : 
		classSelect = redClassSelect
	break;
	case 3 : 
		classSelect = bluClassSelect
	break; 
	}

	

// in order: Primary, Secondary, and Melee
if(GetPropEntityArray(self, "m_hMyWeapons", 0)) local wep0 = GetPropEntityArray(self, "m_hMyWeapons", 0);
if(GetPropEntityArray(self, "m_hMyWeapons", 1)) local wep1 = GetPropEntityArray(self, "m_hMyWeapons", 1);
if(GetPropEntityArray(self, "m_hMyWeapons", 2)) local wep2 = GetPropEntityArray(self, "m_hMyWeapons", 2);

// Place your nerfs / buffs here
switch(classSelect) {
case 1 :
// Scout
if(wep0 != null)
{
wep0.AddAttribute("dmg taken from fire reduced", 0.75, -1);
wep0.AddAttribute("dmg taken from blast reduced", 0.75, -1);
wep0.AddAttribute("dmg taken from bullets reduced", 0.75, -1);
wep0.AddAttribute("dmg bonus vs buildings", 1.25, -1);
}

if(wep1 != null)
{
wep1.AddAttribute("dmg bonus vs buildings", 1.25, -1);
}

if(wep2 != null)
{
wep2.AddAttribute("dmg bonus vs buildings", 1.25, -1);
}

break;
case 2 :
// Sniper
if(wep0 != null)
{
wep0.AddAttribute("dmg taken from blast reduced", 0.67, -1);
wep0.AddAttribute("increase player capture value", 1, -1);
wep0.AddAttribute("dmg taken from bullets reduced", 0.67, -1);
wep0.AddAttribute("mult sniper charge after bodyshot", 1.10, -1);
wep0.AddAttribute("damage bonus", 1.15, -1);
}

if(wep1 != null)
{
wep1.AddAttribute("dmg bonus vs buildings", 1.25, -1);
wep1.AddAttribute("damage bonus", 2.50, -1);
}

if(wep2 != null)
{
wep2.AddAttribute("dmg bonus vs buildings", 1.25, -1);
}
break;
case 3 :
// Soldier



if(wep0 != null)
{
wep0.AddAttribute("dmg bonus vs buildings", 1.25, -1);
wep0.AddAttribute("Reload time increased", 1.15, -1);
wep0.AddAttribute("dmg taken from bullets increased", 1.15, -1);
wep0.AddAttribute("dmg taken from fire increased", 1.15, -1);
}

if(wep1 != null)
{
wep1.AddAttribute("dmg bonus vs buildings", 1.25, -1);
}

if(wep2 != null)
{
wep2.AddAttribute("dmg bonus vs buildings", 1.25, -1);
}
break; 
case 4 :
// Demoman

//self.AddCustomAttribute("dmg taken from bullets increased", 1.15, -1);
//self.AddCustomAttribute("dmg taken from fire increased", 1.15, -1);

if(wep0 != null)
{
wep0.AddAttribute("dmg bonus vs buildings", 1.25, -1);
wep0.AddAttribute("Reload time increased", 1.15, -1);
wep0.AddAttribute("dmg taken from bullets increased", 1.15, -1);
wep0.AddAttribute("dmg taken from fire increased", 1.15, -1);
}

if(wep1 != null)
{
wep1.AddAttribute("Reload time increased", 1.15, -1);
wep1.AddAttribute("dmg bonus vs buildings", 1.25, -1);

}

if(wep2 != null)
{
wep2.AddAttribute("dmg bonus vs buildings", 1.25, -1);
}

break;
case 5 :
// Medic

wep0.AddAttribute("increase player capture value", 1, -1);
wep0.AddAttribute("damage bonus", 2.50, -1);
wep0.AddAttribute("dmg bonus vs buildings", 1.25, -1);
wep0.AddAttribute("dmg taken from fire reduced", 0.75, -1);
wep0.AddAttribute("dmg taken from blast reduced", 0.75, -1);
wep0.AddAttribute("dmg taken from bullets reduced", 0.75, -1);


wep2.AddAttribute("dmg bonus vs buildings", 1.25, -1);
break; 
case 6 :
// Heavy

wep0.AddAttribute("dmg taken from bullets increased", 1.50, -1);
wep0.AddAttribute("dmg taken from blast increased", 1.33, -1);
wep0.AddAttribute("dmg taken from fire increased", 1.50, -1);
wep0.AddAttribute("dmg bonus vs buildings", 1.33, -1);

wep1.AddAttribute("dmg bonus vs buildings", 1.33, -1);

wep2.AddAttribute("dmg bonus vs buildings", 1.33, -1);


break; 
case 7 :
// Pyro



wep0.AddAttribute("weapon burn time increased", 1.33, -1);
wep0.AddAttribute("dmg taken from blast reduced", 0.85, -1);
wep0.AddAttribute("dmg bonus vs buildings", 1.25, -1);
wep0.AddAttribute("dmg taken from fire increased", 1.25, -1);

wep1.AddAttribute("dmg bonus vs buildings", 1.25, -1);
wep1.AddAttribute("weapon burn time increased", 1.33, -1);

wep2.AddAttribute("weapon burn time increased", 1.33, -1);
wep2.AddAttribute("dmg bonus vs buildings", 1.25, -1);
break; 
case 8 :
// Spy

wep0.AddAttribute("dmg taken from fire reduced", 0.50, -1);
wep0.AddAttribute("dmg taken from bullets reduced", 0.50, -1);
wep0.AddAttribute("dmg taken from blast reduced", 0.50, -1);
wep0.AddAttribute("damage bonus", 1.75, -1);
wep0.AddAttribute("dmg penalty vs buildings", 0.67, -1);
wep0.AddAttribute("increase player capture value", 1, -1);
wep2.AddAttribute("damage bonus", 1.75, -1);
wep2.AddAttribute("silent killer", 1, -1);
wep2.AddAttribute("dmg bonus vs buildings", 1.75, -1);
break;
case 9 :
// Engineer

wep0.AddAttribute("dmg bonus vs buildings", 1.25, -1);
wep0.AddAttribute("mult_dmgtaken_active", 1.10, -1);

wep1.AddAttribute("dmg bonus vs buildings", 1.25, -1);

wep2.AddAttribute("dmg penalty vs buildings", 0.67, -1);
wep2.AddAttribute("metal_pickup_decreased", 0.67, -1);
wep2.AddAttribute("Repair rate decreased", 0.67, -1);
wep2.AddAttribute("health from packs decreased", 0.67, -1);
wep2.AddAttribute("health from healers decreased", 0.67, -1);

break;

}


}




function updateVoteText()
{

local newVoteString = "Surrender votes\n" + currentVoteCount + " / " + voteThreshold;
EntFireByHandle(voteText, "AddOutput", "message " + newVoteString, 0, null, null);
EntFireByHandle(voteText, "Display", "", 0, null, null);

}


function voteWin()
{

	local voteEvent = SpawnEntityFromTable("game_round_win", 
	{
	force_map_reset = true,
	switch_teams = true,
	TeamNum = 0
	
	});
	EntFireByHandle(voteEvent, "RoundWin", "", 0.2, null, null);
	
}

function getThreshold()
{

local baseVoteThreshold = getPlayerCount();
voteThreshold = (baseVoteThreshold * 0.5).tointeger();
updateVoteText();

}

function OnGameEvent_teamplay_round_start(params)
{

getThreshold();
if(currentVoteCount != 0) currentVoteCount = 0;
announceClass(0);

if(params.full_reset) {
announceClass(1);
return;
}


}


function getPlayerCount(){
local playerCount = 0;

for (local i = 1; i <= MaxPlayers ; i++)
{
    local player = PlayerInstanceFromIndex(i)
    if (player == null) continue;
    playerCount++
}

return playerCount;


}




function OnGameEvent_player_spawn(params)
{

 local player = GetPlayerFromUserID(params.userid)
 local id = GetPlayerUserID(player);
 
 if(!(id in hasVoted)){
 hasVoted[id] <- 0;
 }
 
setClass(player)
 
//Delete this line if you don't want any balance changes in your map
//EntFireByHandle(player,"RunScriptCode","setup_player()",0.0,player,player);



}

function OnGameEvent_player_disconnect(params)
{

local player = GetPlayerFromUserID(params.userid);
local id = GetPlayerUserID(player);
printl("disconnect");
if(id in hasVoted && hasVoted[id] > 0)
{
currentVoteCount -= 1;
hasVoted[id] <- 0;
}

}




//__CollectGameEventCallbacks(this);
__CollectEventCallbacks(this, "OnGameEvent_", "GameEventCallbacks", RegisterScriptGameEventListener);